import React, { Component } from "react";
import {
  NativeModules,
  StyleSheet,
  View,
  requireNativeComponent
} from "react-native";
import resolveAssetSource from "react-native/Libraries/Image/resolveAssetSource";

const styles = StyleSheet.create({
  base: {
    overflow: "hidden"
  }
});

export default class CastLabsPlayer extends Component {
  constructor(props) {
    super(props);
  }

  _assignRoot = component => {
    this._root = component;
  };

  setNativeProps(nativeProps) {
    this._root.setNativeProps(nativeProps);
  }

  render() {
    const source = resolveAssetSource(this.props.source) || {};

    let uri = source.uri || "";
    if (uri && uri.match(/^\//)) {
      uri = `file://${uri}`;
    }

    if (!uri) {
      console.warn("Trying to load empty source.");
    }

    const nativeProps = Object.assign({}, this.props);
    Object.assign(nativeProps, {
      style: [styles.base, nativeProps.style],
      src: {
        uri
      }
    });

    return (
      <View style={nativeProps.style}>
        <RNCastLabs
          ref={this._assignRoot}
          {...nativeProps}
          style={StyleSheet.absoluteFill}
        />
      </View>
    );
  }
}

const RNCastLabs = requireNativeComponent("RNCastLabs", CastLabsPlayer, {
  nativeOnly: {
    src: true
  }
});
